package com.quran.labs.quransearch;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.AutoCompleteTextView;

import com.quran.labs.quransearch.data.Verse;
import com.quran.labs.quransearch.data.widget.QuranAdapter;

public class QuranSearch extends Activity {

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        AutoCompleteTextView textView =
        	(AutoCompleteTextView)findViewById(R.id.autocomplete);
        QuranAdapter adapter = new QuranAdapter(this, R.layout.search_result);
        textView.setAdapter(adapter);
        
        textView.setOnItemClickListener(new OnItemClickListener(){
			@Override
			public void onItemClick(AdapterView<?> parent, View row,
					int pos, long id) {
				QuranAdapter adapter = (QuranAdapter)parent.getAdapter();
				Verse v = adapter.getItem((int)id);
				showDialog(v);
			}        	
        });
    }
    
    private void showDialog(final Verse verse){
    	String[] items = new String[]{ "View on Quran.com",
    								   "Listen on EveryAyah.com" };
    	AlertDialog.Builder builder = new AlertDialog.Builder(this);
    	builder.setItems(items, new DialogInterface.OnClickListener() {
    		@Override
    		public void onClick(DialogInterface dialog, int which) {
    			String url = "";
    			if (which == 0)
    				url = "http://quran.com/" + verse.getSuraNumber() +
    					"/" + verse.getAyahNumber();
    			else if (which == 1)
    				url = "http://www.everyayah.com/data/Alafasy_128kbps/" +
    					String.format("%03d", verse.getSuraNumber()) +
    					String.format("%03d", verse.getAyahNumber()) + ".mp3";
    			
    			Intent i = new Intent(Intent.ACTION_VIEW);
    			i.setData(Uri.parse(url));
    			startActivity(i);
    		}
    	});
    	builder.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
    		@Override
    		public void onClick(DialogInterface dialog, int which) {
    			dialog.cancel();
    		}
    	});
    	builder.show();
    }
}