package com.quran.labs.quransearch.data;


public class Verse {
	private int id;
	private int suraNumber;
	private int ayahNumber;
	private String transliteration;
	
	public Verse(int id, int sura, int ayah, String transliteration){
		this.id = id;
		this.suraNumber = sura;
		this.ayahNumber = ayah;
		this.transliteration = transliteration;
	}
	
	public int getId() {
		return id;
	}
	
	public void setId(int id) {
		this.id = id;
	}
	
	public int getSuraNumber() {
		return suraNumber;
	}
	
	public void setSuraNumber(int suraNumber) {
		this.suraNumber = suraNumber;
	}
	
	public String getSuraName(){
		return QuranData.getSuraName(getSuraNumber());
	}
	
	public int getAyahNumber() {
		return ayahNumber;
	}
	
	public void setAyahNumber(int ayahNumber) {
		this.ayahNumber = ayahNumber;
	}
	
	public String getTransliteration() {
		return transliteration;
	}
	
	public void setTransliteration(String transliteration) {
		this.transliteration = transliteration;
	}
	
	public void highlight(String query){
		String lower = transliteration.toLowerCase();
		String queryLower = query.toLowerCase();
		int index = lower.indexOf(queryLower);
		if (index == -1) return;
		
		String newStr = transliteration.substring(0, index);
		newStr += "<b>" + transliteration.substring(index,
				index + query.length()) + "</b>";
		newStr += transliteration.substring(index + query.length());
		transliteration = newStr;
	}
	
	@Override
	public String toString(){ 
		String str = getTransliteration();
		return (str == null)? str : str.replaceAll("<b>", "").replaceAll("</b>", "");
	}
}
