package com.quran.labs.quransearch.data.widget;

import java.util.ArrayList;

import android.content.Context;
import android.text.Html;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.Filter;
import android.widget.Filterable;
import android.widget.TextView;

import com.quran.labs.quransearch.R;
import com.quran.labs.quransearch.data.Verse;

public class QuranAdapter extends ArrayAdapter<Verse> implements Filterable {

	private LayoutInflater mInflater;
	private ArrayList<Verse> elements;
	
	public QuranAdapter(Context context, int textViewResourceId) {
		super(context, textViewResourceId);
		mInflater = LayoutInflater.from(context);
		elements = new ArrayList<Verse>();
	}
	
	public int getCount() { return elements.size(); }
	public Verse getItem(int position) { return elements.get(position); }
	public long getItemId(int position) { return position; }
	public void setElements(ArrayList<Verse> items){ this.elements = items; }

	public View getView(int position, View convertView, ViewGroup parent) {
		ViewHolder ayahView;
		
		if (convertView == null) {
			convertView = mInflater.inflate(R.layout.search_result, null);
			ayahView = new ViewHolder();
			ayahView.sura =
				(TextView)convertView.findViewById(R.id.result_loc);
			ayahView.snippet =
				(TextView)convertView.findViewById(R.id.result_text);
			convertView.setTag(ayahView);
		}
		else { ayahView = (ViewHolder) convertView.getTag(); }
		
		Verse v = getItem(position);
		ayahView.sura.setText("Found in Sura " + v.getSuraName() +
				", verse " + v.getAyahNumber());
		ayahView.snippet.setText(Html.fromHtml(v.getTransliteration()));
		return convertView;
	}

	static class ViewHolder {
		TextView sura;
		TextView snippet;
	}

	@Override
	public Filter getFilter() {
		return new QuranFilter(this);
	}
}
