package com.quran.labs.quransearch.data.widget;

import java.util.ArrayList;

import android.widget.Filter;

import com.quran.labs.quransearch.data.QuranData;
import com.quran.labs.quransearch.data.Verse;

public class QuranFilter extends Filter {
	
	private QuranAdapter adapter;
	private QuranData quranData;
	
	public QuranFilter(QuranAdapter adapter){
		this.adapter = adapter;
		quranData = new QuranData();
	}

	@Override
	protected FilterResults performFiltering(CharSequence constraint) {
		FilterResults result = new FilterResults();
		if (constraint != null){
			String query = constraint.toString();
			
			ArrayList<Verse> res = quranData.search(query);
			
			adapter.setElements(res);
			result.values = res;
			result.count = res.size();
		}
		return result;
	}

	@Override
	protected void publishResults(CharSequence constraint, FilterResults results) {
		if ((results != null) && (results.count > 0))
			adapter.notifyDataSetChanged();
	}

}
